<!DOCTYPE html>

<html lang="en" data-content_root="../../../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>sagace.core.storage.file_storage &#8212; sagace 2025 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../../../_static/pygments.css?v=5ecbeea2" />
    <link rel="stylesheet" type="text/css" href="../../../../_static/basic.css?v=b08954a9" />
    <link rel="stylesheet" type="text/css" href="../../../../_static/alabaster.css?v=27fed22d" />
    <script src="../../../../_static/documentation_options.js?v=cb975c41"></script>
    <script src="../../../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" />
   
  <link rel="stylesheet" href="../../../../_static/custom.css" type="text/css" />
  

  
  

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for sagace.core.storage.file_storage</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">--------------------------------------------------------------------------------------------------------------------</span>

<span class="sd">Descrição:</span>
<span class="sd">~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~</span>

<span class="sd">Este módulo define uma estrutura para gerenciamento de tokens de autenticação dentro do sistema SAGACE.</span>
<span class="sd">A classe `FileTokenStorage` implementa a interface `TokenStorage` para armazenar tokens em um arquivo JSON,</span>
<span class="sd">permitindo a persistência do token mesmo após reinicializações do sistema.</span>

<span class="sd">Principais funcionalidades:</span>

<span class="sd">- Armazena tokens de autenticação em um arquivo JSON.</span>
<span class="sd">- Recupera tokens armazenados garantindo sua reutilização.</span>
<span class="sd">- Implementa a interface `TokenStorage`, garantindo flexibilidade e substituição de implementação.</span>

<span class="sd">Princípios de Design Aplicados:</span>

<span class="sd">- **Single Responsibility Principle (SRP - SOLID)**: A classe tem a única responsabilidade de armazenar tokens em arquivos.</span>
<span class="sd">- **Open/Closed Principle (OCP - SOLID)**: `FileTokenStorage` pode ser estendida sem modificar seu código-fonte.</span>
<span class="sd">- **Dependency Inversion Principle (DIP - SOLID)**: `FileTokenStorage` depende da abstração `TokenStorage`, permitindo flexibilidade.</span>

<span class="sd">Classes:</span>
<span class="sd">- ``FileTokenStorage``: Implementação concreta de `TokenStorage` utilizando arquivos JSON.</span>

<span class="sd">Exemplo de uso:</span>

<span class="sd">.. code-block:: python</span>

<span class="sd">    from sagace.core import Token, FileTokenStorage</span>

<span class="sd">    token_storage = FileTokenStorage(&quot;token.json&quot;)</span>
<span class="sd">    token = Token(</span>
<span class="sd">        base_url=&quot;https://api.sagace.online&quot;,</span>
<span class="sd">        access_token=&quot;abc123&quot;,</span>
<span class="sd">        application_name=&quot;Meu App&quot;,</span>
<span class="sd">        description=&quot;Token de acesso persistente.&quot;</span>
<span class="sd">    )</span>
<span class="sd">    token_storage.save_token(token)</span>
<span class="sd">    retrieved_token = token_storage.get_token()</span>
<span class="sd">    print(retrieved_token.get_auth_header())</span>

<span class="sd">Autor: Diego Yosiura</span>
<span class="sd">Última Atualização: 27/02/2025 16:24</span>
<span class="sd">Criado em: 27/02/2025 16:24</span>
<span class="sd">Copyright: (c) Ampere Consultoria Ltda</span>
<span class="sd">Projeto Original: sagace-v2-package</span>
<span class="sd">IDE: PyCharm</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">import</span><span class="w"> </span><span class="nn">json</span>
<span class="kn">from</span><span class="w"> </span><span class="nn">..</span><span class="w"> </span><span class="kn">import</span> <span class="n">Token</span>
<span class="kn">from</span><span class="w"> </span><span class="nn">..</span><span class="w"> </span><span class="kn">import</span> <span class="n">TokenStorage</span>


<div class="viewcode-block" id="FileTokenStorage">
<a class="viewcode-back" href="../../../../sagace.core.storage.html#sagace.core.storage.file_storage.FileTokenStorage">[docs]</a>
<span class="k">class</span><span class="w"> </span><span class="nc">FileTokenStorage</span><span class="p">(</span><span class="n">TokenStorage</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Implementação de `TokenStorage` para persistência de tokens em arquivos JSON.</span>

<span class="sd">    Esta classe permite armazenar tokens de autenticação em arquivos JSON para garantir sua persistência,</span>
<span class="sd">    garantindo que as credenciais sejam mantidas mesmo após reinicializações do sistema.</span>

<span class="sd">    Princípios aplicados:</span>

<span class="sd">    - **Single Responsibility Principle (S - SOLID)**: Responsável apenas por salvar e recuperar tokens de arquivos.</span>
<span class="sd">    - **Dependency Inversion Principle (D - SOLID)**: Depende da abstração `TokenStorage`, garantindo desacoplamento.</span>

<span class="sd">    :param token_file: Caminho do arquivo onde o token será armazenado.</span>
<span class="sd">    :type token_file: str</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">def</span><span class="w"> </span><span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">token_file</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Inicializa a classe `FileTokenStorage` definindo o arquivo de armazenamento do token.</span>

<span class="sd">        :param token_file: Caminho do arquivo onde o token será armazenado.</span>
<span class="sd">        :type token_file: str</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">token_file</span> <span class="o">=</span> <span class="n">token_file</span>

<div class="viewcode-block" id="FileTokenStorage.save_token">
<a class="viewcode-back" href="../../../../sagace.core.storage.html#sagace.core.storage.file_storage.FileTokenStorage.save_token">[docs]</a>
    <span class="k">def</span><span class="w"> </span><span class="nf">save_token</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">token</span><span class="p">:</span> <span class="n">Token</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Armazena o token em um arquivo JSON.</span>

<span class="sd">        :param token: Instância do token a ser armazenado.</span>
<span class="sd">        :type token: Token</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">token_file</span><span class="p">,</span> <span class="s2">&quot;w&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">json</span><span class="o">.</span><span class="n">dump</span><span class="p">({</span>
                <span class="s2">&quot;base_url&quot;</span><span class="p">:</span> <span class="n">token</span><span class="o">.</span><span class="n">base_url</span><span class="p">,</span>
                <span class="s2">&quot;access_token&quot;</span><span class="p">:</span> <span class="n">token</span><span class="o">.</span><span class="n">access_token</span><span class="p">,</span>
                <span class="s2">&quot;application_name&quot;</span><span class="p">:</span> <span class="n">token</span><span class="o">.</span><span class="n">application_name</span><span class="p">,</span>
                <span class="s2">&quot;description&quot;</span><span class="p">:</span> <span class="n">token</span><span class="o">.</span><span class="n">description</span><span class="p">,</span>
                <span class="s2">&quot;token_type&quot;</span><span class="p">:</span> <span class="n">token</span><span class="o">.</span><span class="n">token_type</span>
            <span class="p">},</span> <span class="n">f</span><span class="p">)</span></div>


<div class="viewcode-block" id="FileTokenStorage.get_token">
<a class="viewcode-back" href="../../../../sagace.core.storage.html#sagace.core.storage.file_storage.FileTokenStorage.get_token">[docs]</a>
    <span class="k">def</span><span class="w"> </span><span class="nf">get_token</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Token</span><span class="p">:</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Recupera o token armazenado no arquivo JSON.</span>

<span class="sd">        :return: Instância do token armazenado.</span>
<span class="sd">        :rtype: Token</span>
<span class="sd">        :raises ValueError: Se o arquivo de token não for encontrado.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">token_file</span><span class="p">,</span> <span class="s2">&quot;r&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                <span class="n">data</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
                <span class="k">return</span> <span class="n">Token</span><span class="p">(</span>
                    <span class="n">base_url</span><span class="o">=</span><span class="n">data</span><span class="p">[</span><span class="s2">&quot;base_url&quot;</span><span class="p">],</span>
                    <span class="n">access_token</span><span class="o">=</span><span class="n">data</span><span class="p">[</span><span class="s2">&quot;access_token&quot;</span><span class="p">],</span>
                    <span class="n">application_name</span><span class="o">=</span><span class="n">data</span><span class="p">[</span><span class="s2">&quot;application_name&quot;</span><span class="p">],</span>
                    <span class="n">description</span><span class="o">=</span><span class="n">data</span><span class="p">[</span><span class="s2">&quot;description&quot;</span><span class="p">],</span>
                    <span class="n">token_type</span><span class="o">=</span><span class="n">data</span><span class="p">[</span><span class="s2">&quot;token_type&quot;</span><span class="p">]</span>
                <span class="p">)</span>
        <span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;Token file not found.&quot;</span><span class="p">)</span></div>
</div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="Main">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../../index.html">sagace</a></h1>









<search id="searchbox" style="display: none" role="search">
    <div class="searchformwrapper">
    <form class="search" action="../../../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" placeholder="Search"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</search>
<script>document.getElementById('searchbox').style.display = "block"</script><h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Conteúdo:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../modules.html">sagace</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../../index.html">Documentation overview</a><ul>
  <li><a href="../../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &#169;2025, Ampere Consultoria.
      
      |
      Powered by <a href="https://www.sphinx-doc.org/">Sphinx 8.2.1</a>
      &amp; <a href="https://alabaster.readthedocs.io">Alabaster 1.0.0</a>
      
    </div>

    

    
  </body>
</html>